// Initialize the settings window.
function loadSettings() {    
 System.Gadget.onSettingsClosing = SettingsClosing;
 size.value = System.Gadget.Settings.read("SetSize"); 
 // Load mode.
 diskmode = System.Gadget.Settings.read("WhichDrivesICanSee");
 dskmode.value = diskmode;
 // Load excluded drives.
 var mask = parseInt(System.Gadget.Settings.read("ExcludedDrives"));
 if (!isNaN(mask)) {
   txtExcludedDrives.value = maskToString(mask);
 }
}

// Settings page closing handler.
function SettingsClosing(event) {
 if (event.closeAction == event.Action.commit) {
  System.Gadget.Settings.write("SetSize", size.value);  
  System.Gadget.Settings.write("WhichDrivesICanSee", dskmode.value);
  // Convert string of excluded drive letters to a bit mask and save.
  var mask = stringToMask(txtExcludedDrives.value);
  System.Gadget.Settings.write("ExcludedDrives", mask);
 }    
 event.cancel = false;
}

function maskToString(mask) {
 var temp = "";
 for (var i = 0; i < 26; i++) {
  var letterValue = Math.pow(2, i);
  if ((letterValue & mask) == letterValue) {
   temp += String.fromCharCode(65 + i);
  }
 }
 return temp;    
}

function stringToMask(value) {
  value = value.toUpperCase();
  var mask = 0;
  for (var i = 0; i < value.length; i++) {
    var letterValue = value.charCodeAt(i) - 65;
    if (letterValue < 0 || letterValue > 25) {
      continue;
    }
    mask |= Math.pow(2, letterValue);
  }
  return mask;
}

function checkforupdate(){
 var vString = "";
 var url = "http://shvaika.ic.ck.ua/gadgets/monitors/DrivesMonitor/DrivesMonitorversioninfo.xml";
 var xmlHttp = null;

 try
  {
   var xmlHttp = new XMLHttpRequest();
   xmlHttp.open("GET", url, true); //true mean call is asynchronous
   xmlHttp.setRequestHeader("If-Modified-Since", "Sat, 1 Jan 2000 00:00:00 GMT"); //for non cached
 
   xmlHttp.onreadystatechange = function() {
    // Verify that the document is ready to parse.
    if (xmlHttp.readyState == 4) {  
     // Makes sure it found the file.
     if (xmlHttp.status == 200) {
      // Extract information
      var newVersion = xmlHttp.responseXML.getElementsByTagName("version")[0].firstChild.nodeValue;
      var updateUrl = xmlHttp.responseXML.getElementsByTagName("url")[0].firstChild.nodeValue;
     // Compare and show message if a newer version is available.
      if (newVersion > System.Gadget.version) 
       {
        vString = "<font color='#FF0000'><strong> !</strong><br /> : " + System.Gadget.version + "<br />";
	    vString += "<strong><a href='" + updateUrl + "' onclick='System.Gadget.close()' ";
	    vString += "title='   (" + newVersion + ")'>   (" + newVersion + ")</a></strong></font>";
        updatebutton.style.top = 152;
	    updatebutton.innerHTML = vString;
	   }
	  else 
	   {
        updatebutton.style.top = 160;
        updatebutton.innerHTML = "<font color='#008000'><strong> !</strong><br /><small>     :)</small></font>";
	   }
     }//end status
    else
     {
      updatebutton.style.top = 160;
      updatebutton.innerHTML = "<font color='#FF0000'><strong>     Intrenet</strong><br /> .   <b>" + xmlHttp.status + "</b></font>";
     }
    }//end readyState
   }//end function
   xmlHttp.send(null);
  }//end try
 catch (err) 
  {
   updatebutton.style.top = 160;
   vString = "<font color='#FF0000'> .   <small>" + err + "</small></font>";
  }
}
